#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;


int main(){
    int n;
    cin>>n;
    vector<int> arr(n);
    for (int i=0; i<n; i++){
        cin>>arr[i];
    }
    vector<int> sarr=arr;
    sort(sarr.begin(), sarr.end());
    vector<pair<int, int>> ans={};
    for (int i=0; i<n; i++){
        if (arr[i]!=sarr[i]){
            int ind=i+1;
            while (arr[ind]!=sarr[i]){
                ind++;
            }
            reverse(arr.begin()+i, arr.begin()+ind+1);
            pair<int, int> aboba;
            aboba.first=i+1;
            aboba.second=ind+1;
            ans.push_back(aboba);
        }
    }
    cout<<ans.size()<<endl;
    for (int i=0; i<ans.size(); i++){
        cout<<ans[i].first<<" "<<ans[i].second<<endl;
    }
}
